; 436M5M.asm  PLL:TB31213FN(FMTCXO=12.8MHz)
;------------------------------------------------------------------
;20080617- V1.00
; PIC16F648 Portmap
; RA1(18)------ CWTX CK
; RA2(1)------- CWTX DATA
; RA3(2)------- CWTX STB
; RB7(13)------ KEY OUT
; RB6(12)------ FMRX CK
; RB5(11)------ FMRX DATA
; RB4(10)------ FMRX STB
; RB3(9)------- FMTX STB
; RB2(8)------- FMTX DATA
; RB1(7)------- FMTX CK
; RB0(6)------- (RECEIVE DATA)
	LIST    p=16F648A 
#INCLUDE <P16F648A.INC>	;
  __CONFIG _CP_OFF&_WDT_OFF&_BODEN_OFF&_PWRTE_OFF&_XT_OSC&_MCLRE_ON&_LVP_OFF
;------ Reg. Map --------
DR1	EQU	21H
TM1	EQU	22H
TM2	EQU	23H
TM3	EQU	24H

;----- Defined Freq -----
REF1M	EQU	25H	;̧ݽ Nref ---MSB
REF1L	EQU	26H	;̧ݽ Nref ---LSB
;
CH1H	EQU	27H	;۸ٶ Nprg ---MSB
CH1M	EQU	28H	;۸ٶ Nprg 
CH1L	EQU	29H	;۸ٶ Nprg ---LSB
;
FMCWRX	EQU	2AH	;FM/CW/RX
;------------------ MAIN PROG. --------------------------
	ORG	0
MAIN	CALL	INIT
	CALL	TIM20
	CALL	TIM20
;
	CALL	FMRX10		;FMRXPLLݒ (436.500MHz)
;
;SLP	SLEEP
;
MAINEND	GOTO	MAINEND
;
;-------------------------------------------------------
FMRX10	CALL	OPINIT		;߼ڼ޽ݒ
	MOVLW	00AH		;******** t@X---MSB **********
	MOVWF	REF1M
	MOVLW	000H		;******** t@X---LSB **********
	MOVWF	REF1L
	CALL	RFDOUT		;̧ݽڼ޽ݒ(12.8/2560=0.005MHz/Step)
	MOVLW	001H		;******** gf[^w---MSB **********
	MOVWF	CH1H
	MOVLW	044H		;******** gf[^w-----  **********
	MOVWF	CH1M
	MOVLW	04CH		;******** gf[^w---LSB **********
	MOVWF	CH1L
	CALL	OUTFQ		;۸ڼ޽ݒ(436.500-21.4=415.1MHz)
	RETURN			;
;-------------------------------------------------------
OUTFQ	NOP			;۸ڼ޽ݒ
	MOVF	CH1L,0		;
	MOVWF	DR1
	CALL	SFTDT
	CALL	SFTDT
	CALL	SFTDT
	CALL	SFTDT
	CALL	SFTDT
	CALL	SFTDT
	CALL	SFTDT
	CALL	SFTDT
	MOVF	CH1M,0		;-----
	MOVWF	DR1
	CALL	SFTDT
	CALL	SFTDT
	CALL	SFTDT
	CALL	SFTDT
	CALL	SFTDT
	CALL	SFTDT
	CALL	SFTDT
	CALL	SFTDT
	MOVF	CH1H,0		;-----
	MOVWF	DR1
	CALL	SFTDT
	CALL	H_OUT		;-----
	CALL	L_OUT
	CALL	STBOUT
	RETURN			;
;------------------------
RFDOUT	MOVF	REF1L,0		;̧ݽڼ޽ݒ
	MOVWF	DR1
	CALL	SFTDT
	CALL	SFTDT
	CALL	SFTDT
	CALL	SFTDT

	CALL	SFTDT
	CALL	SFTDT
	CALL	SFTDT
	CALL	SFTDT

	MOVF	REF1M,0		;-----
	MOVWF	DR1
	CALL	SFTDT
	CALL	SFTDT
	CALL	SFTDT
	CALL	SFTDT

	CALL	H_OUT	;group CoDE:'11' is REF.DEV
	CALL	H_OUT
	CALL	STBOUT
	RETURN			;
;------------------------
SFTDT	NOP
	BTFSC	DR1,0
	GOTO	SFTDT1
	CALL	L_OUT
	GOTO	SFTDT2
SFTDT1	CALL	H_OUT
SFTDT2	RRF	DR1,1
	RETURN			;
;------------------------
OPINIT	CALL	L_OUT	;T1 	;߼ڼ޽ݒ
	CALL	L_OUT	;T2
	CALL	L_OUT	;T3
	CALL	H_OUT	;CpT1
	CALL	H_OUT	;CpT2
	CALL	L_OUT	;Cpr1
	CALL	L_OUT	;Cpr2
	CALL	L_OUT	;LD1
	CALL	L_OUT	;LD2
	CALL	L_OUT	;Tx
	CALL	H_OUT	;rx
	CALL	L_OUT	;group CoDE:'00' is option reg.
	CALL	L_OUT	;
	CALL	STBOUT
	RETURN			;
;------------------------
L_OUT	BCF	PORTB,5
	NOP
	BSF	PORTB,6
	NOP
	BCF	PORTB,6
	RETURN			;
;
H_OUT	BSF	PORTB,5
	NOP
	BSF	PORTB,6
	NOP
	BCF	PORTB,6
	RETURN			;
;
STBOUT	BSF	PORTB,4
	NOP
	BCF	PORTB,4
	RETURN			;
;------------------------------
; ^C}P
TIM10	MOVLW	0FFH
	MOVWF	TM1
TIM11	NOP
	DECFSZ	TM1,1
	GOTO	TIM11
	RETURN
; ^C}Q
TIM20	MOVLW	040H
	MOVWF	TM2
TIM21	NOP
	CALL	TIM10
	DECFSZ	TM2,1
	GOTO	TIM21
	RETURN
; ^C}R
TIM30	MOVLW	090H
	MOVWF	TM3
TIM31	NOP
	CALL	TIM10
	DECFSZ	TM3,1
	GOTO	TIM31
	RETURN
;------------------------
INIT	BSF	STATUS,RP0	;BANK=1
        MOVLW	b'10000000'		;
	MOVWF	OPTION_REG	;PORTB=ٱߖ,ؽׂ1/2TMRO
	MOVLW	b'00000001'	;PORTB I/O
	MOVWF	TRISB
	BCF	STATUS,RP0	;BANK=0
	MOVLW	b'00000000'	;PORTBo̓x
	MOVWF	PORTB
;
	CLRF	PORTA
	MOVLW	0x07		;Turn comparators off
	MOVWF	CMCON		;enable pins for I/O
	BCF	STATUS,RP1
	BSF	STATUS, RP0	;BANK=1
	MOVLW	b'00000000'	;PORTA I/O
	MOVWF	TRISA		;
	BCF	STATUS, RP0	;BANK=0
;
	BSF	PORTA,0		;LED ON
	BCF	INTCON,GIE	;۰ي֎~
	RETURN
;------------------------
	END
